/***************************************************************************
                          sqlgui_part.cpp  -  description
                             -------------------
    begin                : Sat Apr 14 18:28:06 CEST 2001
    copyright            : (C) 2001 by mb
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// include files for QT
#include <qdir.h>
#include <qprinter.h>
#include <qpainter.h>
#include <kurl.h>
#include <qtranslator.h>

// include files for KDE
#include <kiconloader.h>
#include <kmessagebox.h>
#include <kfiledialog.h>
#include <kmenubar.h>
#include <klocale.h>
#include <kconfig.h>
#include <kstdaction.h>
#include <kstatusbar.h>
#include <kservicetype.h>
#include <kapplication.h>
#include <kaction.h>
#include <kio/jobclasses.h>
#include <kio/job.h>
#include <kio/global.h>

// application specific includes
#include "sqlgui_part.h"
#include "sqlguiview.h"
#include "sqlguidoc.h"
#include <klineeditdlg.h>

#include "loginbox.h"

#include <qmessagebox.h> 
#include <qnamespace.h>
#include <qregexp.h>
#include <kparts/part.h>
#include <kparts/browserextension.h>
#include <kaboutdata.h>

#include "tablegenerator.h"
#include "basecreator.h"

#include "sqlgui_factory.h"

#include <iostream>
#include <iomanip>

#include <kio/slaveinterface.h>
#include <kio/slavebase.h>
#include <kio/connection.h>
#include <kio/slave.h>
#include <kextsock.h>
#include <ksock.h>

#include "sqlgui_factory.h"

#include <iostream>
#include <iomanip>

#define ID_STATUS_MSG 1

using namespace KIO;

SqlGuiPart::SqlGuiPart(QWidget* parentWidget, const char* widgetName, QObject* parent, const char* name, const QStringList &args ): KParts::ReadOnlyPart(parent, name)
{
  myParentWidget = parentWidget;
  setInstance( SqlGuiFactory::instance() );
//  setXMLFile( "/home/marcus/sqlguipart/sqlguipart/sqlguipart.rc" );
  setXMLFile( "sqlguipart/sqlguipart.rc" );


	// This doesn't work here, this is a dumb KDE-library:
	//  QTranslator translator( 0 );
	//  translator.load( "sqlguipart", "." );
	//  qApp->installTranslator( &translator );

	// Translation in kparts suxx!!!
	// The loaded part does NOT get translated automatically just by using the i18n macro, like in usual apps!
	
	const QString catalogue = "sqlguipart";
	kl = new KLocale( catalogue, 0 );
	kl->setActiveCatalogue( catalogue );
	kl->setMainCatalogue( "sqlguipart" );

	// Try this, and you'll see:
	//	cout << kl->translate( i18n("Table") ).latin1() << endl;    // works
	//	cout << kl->translate( "Table" ).latin1() << endl;          // works
	//	cout <<  i18n("Table")  << endl;                            // doesn't work


  initActions();
  initDocument();
  
  config = new KConfig( "sqlguipartrc", false, true, "config");

  readOptions();
  initView( myParentWidget );
  view->setDocument( doc );
  doc->setView( view );

  (void) new KParts::BrowserExtension( this );

  ((QWidget*)view)->setFocusPolicy(QWidget::ClickFocus);

  connect( doc, SIGNAL( DbQueryError( QString* ) ), this, SLOT( slotDisplayErrorMsg(QString *) ) );
  connect( doc, SIGNAL( connectionChanged() ), view, SLOT( slotUpdateMainView() ) );
  connect( doc, SIGNAL( connectionChanged() ), this, SLOT( slotSomethingChanged() ) );
  connect( doc, SIGNAL( connectionChanged() ), this, SIGNAL( connectionComplete() ) );

  connect( doc, SIGNAL( loginError() ), this, SLOT( slotSomethingWeirdHappened() ) );

  connect( view, SIGNAL( doQuery(QString*, QString*) ), doc, SLOT( slotDoQuery(QString*, QString* )  )  );
  connect( view, SIGNAL( statusBarRequest( const QString & ) ), this, SLOT( slotStatusMsg( const QString & ) ) );
  connect( view, SIGNAL( serverStatusRequested() ), doc, SLOT( slotServerStatus() ) );
  connect( doc, SIGNAL( serverStatus( QString ) ), this, SLOT( slotShowServerStatus( QString ) ) );
	connect( view, SIGNAL( countRowRequested( QString*, QString* ) ), doc, SLOT( slotCountRows( QString*, QString* ) ) );
	connect( view, SIGNAL( selectionChanged( bool ) ), this, SLOT( slotEnableExport( bool ) ) );


  connect( doc, SIGNAL( resultChanged() ), view, SLOT( slotUpdateResultList() ) );
  connect( doc, SIGNAL( lastActionChanged( QString*, QString*, QString* ) ), view, SLOT( slotUpdateLastAction( QString*, QString*, QString* ) ) );
  connect( view, SIGNAL( createTable() ), this,  SLOT( slotFileNew() ));
  connect( view, SIGNAL( createDb() ), this,  SLOT( slotBaseNew() ));
  connect( doc, SIGNAL( QueryDone() ), view, SLOT( slotQueryDone() ) );
  connect( doc, SIGNAL( DbQueryError( QString* ) ), view, SLOT( slotQueryUnDone() ) );

  connect( view, SIGNAL( deleteDb( QString* ) ), doc,  SLOT( slotDbDelete( QString* ) ));
  connect( view, SIGNAL( deleteTable( QString*, QString* ) ), doc,  SLOT( slotTableDelete( QString*, QString* ) ));
  connect( view, SIGNAL( checkTable( QString*, QString* ) ), doc,  SLOT( slotTableCheck( QString*, QString* ) ));
  connect( view, SIGNAL( optimizeTable( QString*, QString* ) ), doc,  SLOT( slotTableOptimize( QString*, QString* ) ));
  connect( view, SIGNAL( repairTable( QString*, QString* ) ), doc,  SLOT( slotTableRepair( QString*, QString* ) ));
  connect( view, SIGNAL( gotResult() ), doc,  SLOT( slotClearMemory() ));


  ///////////////////////////////////////////////////////////////////
  // disable actions at startup
  fileSave->setEnabled( false );
  fileSaveAs->setEnabled(false);
  filePrint->setEnabled(false);
  editCut->setEnabled(false);
  editCopy->setEnabled(false);
  editPaste->setEnabled(false);

  slotSetFastMode();

}

SqlGuiPart::~SqlGuiPart()
{
	saveOptions();
}

bool SqlGuiPart::process(const QCString &fun, const QByteArray &data, QCString &replyType, QByteArray &replyData)
{
return true;
}



////////////////////////////////////////////////////////
// ToDo: Kio implementieren...
////////////////////////////////////////////////////////

///////////////
//  Remark:  //
///////////////////////////////////////////////////////////////////////////////////
//
//        T H E   K I O   D O C U M E N T A T I O N   S U X X     ! ! ! ! ! ! ! ! !
//
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////


void SqlGuiPart::slotData( KIO::Job* kio_job, const QByteArray & d ){
//void SqlGuiPart::slotData( const QByteArray & d ){
  QString* submittedData = new QString( d );
  KURL* submittedUrl = new KURL( *submittedData );
	cout << "SqlGuiPart::slotData(): got data: " << submittedUrl->prettyURL() << endl;
	if (submittedUrl->protocol().compare("mysql") == 0)  slotFileOpenRecent( *submittedUrl );
}


int SqlGuiPart::read( int* _cmd, QByteArray & d ){
  QString* submittedData = new QString( d );
  KURL* submittedUrl = new KURL( *submittedData );
	cout << "SqlGuiPart::slotData(): got data: " << submittedUrl->prettyURL() << endl;
	if (submittedUrl->protocol().compare("mysql") == 0)  slotFileOpenRecent( *submittedUrl );
}


////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////
// ToDo: Ende...
////////////////////////////////////////////////////////


bool SqlGuiPart::isConnected(){
	return doc->isConnected();
}

KAboutData* SqlGuiPart::createAboutData(){
	KAboutData* aboutData = new KAboutData( "sqlgui", I18N_NOOP("SqlGui"), "0.4", I18N_NOOP("A graphical frontend for MySql"), KAboutData::License_GPL, "(c) 1999 - 2002, Marcus Beranek <marcus@sqlgui.de>" );
	aboutData->addAuthor(I18N_NOOP("Official website and contact"),"","marcus@sqlgui.de","http://www.sqlgui.de");
	aboutData->addAuthor(I18N_NOOP("Marcus Beranek (Author)"),"","marcus@beranek.de","http://www.beranek.de");
	return aboutData;
}

void SqlGuiPart::slotShowServerStatus( QString stat )
{
	// z.B.: Uptime: 9607  Threads: 1  Questions: 1185  Slow queries: 0  Opens: 473  Flush tables: 1  Open tables: 64 Queries per second avg: 0.123
	stat.replace(QRegExp("Threads"), "\nThreads");
	stat.replace(QRegExp("Questions"), "\nQuestions");
	stat.replace(QRegExp("Slow"), "\nSlow");
	stat.replace(QRegExp("Open"), "\nOpen");
	stat.replace(QRegExp("Flush"), "\nFlush");
	stat.replace(QRegExp("Queries"), "\nQueries");

	QString *h = new QString("Host: ");
	h->append( doc->getHost() );
	h->append("\n\n");

	stat.prepend(*h);	

  QMessageBox::information( myParentWidget, kl->translate(i18n( "Server-Status" )).local8Bit() , kl->translate( i18n( stat.latin1() )));
}

base_t SqlGuiPart::getDBObj()
{
	return *( doc->getDBs() );
}

void SqlGuiPart::slotDocReConnect()
{
  doc->slotReConnect();
}

void SqlGuiPart::slotEnableExport( bool on )
{
	fileSave->setEnabled( on );
}

void SqlGuiPart::slotDeleteTableRequest()
{
  view->deleteTable();
}

void SqlGuiPart::slotDeleteBaseRequest()
{
  view->deleteBase();
}

void SqlGuiPart::slotSomethingChanged()
{
  emit( userChanged( doc->getUser() ) );
  emit( hostChanged( doc->getHost() ) );
	saveOptions();
  if( doc->getDBs() ){
    emit(setStatusBarText( QString::QString( "Connected" )));
  }
}

void SqlGuiPart::slotSomethingWeirdHappened()
{
  emit( userChanged( QString::QString("No user") ) );
  emit( hostChanged( QString::QString("No host") ) );
  emit( setStatusBarText( QString::QString( "Not connected" ) ) );
}



void SqlGuiPart::initActions()
{
	
  fileNewBase = new KAction( kl->translate(i18n("Create &Base")) , "filenew", 0, this, SLOT(slotBaseNew()), actionCollection(), "file_create_base");
  fileReConnect = new KAction(kl->translate(i18n("&Reconnect")), "reload", 0, this, SLOT(slotDocReConnect()), actionCollection(), "file_reconnect_base");
  fileNew = new KAction(kl->translate(i18n("Create &Table")), "filenew", 0, this, SLOT(slotFileNew()), actionCollection(), "file_create_table");
  fileDeleteTable = new KAction(kl->translate(i18n("Delete Table")), "fileclose", 0, this, SLOT(slotDeleteTableRequest()), actionCollection(), "file_delete_table");
  fileDeleteBase = new KAction(kl->translate(i18n("Delete Base")), "fileclose", 0, this, SLOT(slotDeleteBaseRequest()), actionCollection(),"file_delete_base");

	databaseInsertData = new KAction(kl->translate(i18n("Insert new data")), "filenew", 0, this, SLOT(slotInsertDataRequest()), actionCollection(),"file_add_tabledata");

  fileOpen = KStdAction::open(this, SLOT(slotFileOpen()), actionCollection());  // open host
  fileOpen->setText(kl->translate( i18n("&Open host")));

  fileOpenRecent = KStdAction::openRecent(this, SLOT(slotFileOpenRecent(const KURL&)), actionCollection());

  fileSave = KStdAction::save(this, SLOT(slotFileSave()), actionCollection());
  fileSaveAs = KStdAction::saveAs(this, SLOT(slotFileSaveAs()), actionCollection());
  fileClose = KStdAction::close(this, SLOT(slotFileClose()), actionCollection());
  filePrint = KStdAction::print(this, SLOT(slotFilePrint()), actionCollection());
  fileQuit = KStdAction::quit(this, SLOT(slotFileClose()), actionCollection());
  editCut = KStdAction::cut(this, SLOT(slotEditCut()), actionCollection());
  editCopy = KStdAction::copy(this, SLOT(slotEditCopy()), actionCollection());
  editPaste = KStdAction::paste(this, SLOT(slotEditPaste()), actionCollection());
  viewToolBar = KStdAction::showToolbar(this, SLOT(slotViewToolBar()), actionCollection());
  viewStatusBar = KStdAction::showStatusbar(this, SLOT(slotViewStatusBar()), actionCollection());
  setFastMode = new KToggleAction(kl->translate( i18n("Fast-Mode (experimental)")), QIconSet( QPixmap() ), 0, this, SLOT(slotSetFastMode()), actionCollection(),"set_fastmode");

  fileNew->setToolTip(kl->translate( i18n("Creates a new table")));
  fileOpen->setToolTip(kl->translate(i18n("Opens a connection to a mysql-host")));
  fileOpenRecent->setToolTip(kl->translate(i18n("Opens a recently used file")));
  fileSave->setToolTip(kl->translate(i18n("Saves the actual document")));
  fileSaveAs->setToolTip(kl->translate(i18n("Saves the actual document as...")));
  fileClose->setToolTip(kl->translate(i18n("Closes the actual document")));
  filePrint ->setToolTip(kl->translate(i18n("Prints out the actual document")));
  fileQuit->setToolTip(kl->translate(i18n("Quits the application")));
  editCut->setToolTip(kl->translate(i18n("Cuts the selected section and puts it to the clipboard")));
  editCopy->setToolTip(kl->translate(i18n("Copies the selected section to the clipboard")));
  editPaste->setToolTip(kl->translate(i18n("Pastes the clipboard contents to actual position")));
  viewToolBar->setToolTip(kl->translate(i18n("Enables/disables the toolbar")));
  viewStatusBar->setToolTip(kl->translate(i18n("Enables/disables the statusbar")));
	setFastMode->setToolTip(kl->translate(i18n("Enables/disables fastmode")));

}

void SqlGuiPart::slotInsertDataRequest(){
	view->slotAddTableData();
}

void SqlGuiPart::initDocument()
{
  doc = new SqlGuiDoc( myParentWidget );
  doc->newDocument();
}

void SqlGuiPart::initView( QWidget* parentWidget )
{ 
  view = new SqlGuiView( (QWidget*) parentWidget);
  doc->addView(view);
  setWidget(view);
  view->show();
  ((QWidget*)view)->setFocus();
}

void SqlGuiPart::openDocumentFile(const KURL& url)
{
  fileOpenRecent->addURL( url );
	saveOptions();
}


SqlGuiDoc *SqlGuiPart::getDocument() const
{
	cout << "...entering SqlGuiPart::getDocument" << endl;
  return doc;
}

SqlGuiView *SqlGuiPart::getView() const
{
  return view;
}

void SqlGuiPart::saveOptions()
{	
  config->setGroup("General Options");
	config->setReadOnly(false);
  config->writeEntry("Fast-Mode",setFastMode->isChecked());
  fileOpenRecent->saveEntries(config);
	config->sync();
}

QString SqlGuiPart::getHostname(){
	return doc->getHost();
}

QString SqlGuiPart::getUser(){
	return doc->getUser();
}

QString SqlGuiPart::getProtocol(){
	return( QString::QString("mysql") );
}


void SqlGuiPart::readOptions()
{
	
  config->setGroup("General Options");

	// Fast-Mode (Default is NOT to use fastmode):
  bool bFastMode = config->readBoolEntry("Fast-Mode", false);
  setFastMode->setChecked(bFastMode);

	// Recent files:
  fileOpenRecent->loadEntries(config);

}

void SqlGuiPart::saveProperties(KConfig *_cfg)
{
  if(doc->URL().fileName()!= i18n("Untitled") && !doc->isModified())
  {
    // saving to tempfile not necessary

  }
  else
  {
    KURL url=doc->URL();	
    _cfg->writeEntry("filename", url.url());
    _cfg->writeEntry("modified", doc->isModified());
    QString tempname = kapp->tempSaveName(url.url());
    QString tempurl= KURL::encode_string(tempname);
    KURL _url(tempurl);
    doc->saveDocument(_url);
  }
}


void SqlGuiPart::readProperties(KConfig* _cfg)
{
  QString filename = _cfg->readEntry("filename", "");
  KURL url(filename);
  bool modified = _cfg->readBoolEntry("modified", false);
  if(modified)
  {
    bool canRecover;
    QString tempname = kapp->checkRecoverFile(filename, canRecover);
    KURL _url(tempname);
  	
    if(canRecover)
    {
      doc->setModified();
      QFile::remove(tempname);
    }
  }
  else
  {
    if(!filename.isEmpty())
    {
		// nothin...
    }
  }
}		

bool SqlGuiPart::queryClose()
{
  saveOptions();
  return true;
}

bool SqlGuiPart::queryExit()
{
  saveOptions();
  return true;
}

void SqlGuiPart::slotDisplayErrorMsg(QString * msg)
{
  QMessageBox::information( myParentWidget, kl->translate(i18n( "ERROR" )), kl->translate(i18n( msg->latin1() )) );
  slotSomethingWeirdHappened();
  // emit( setStatusBarText( QString::QString( "Not connected" ) ) );
}

void SqlGuiPart::slotFileNew()
{

	if(isConnected()){
	  tableGenerator *tGen = new tableGenerator(view->selectedDB() );
	  tGen->show();

	  connect( tGen, SIGNAL( createTableRequest( QString*, QString* ) ), doc, SLOT(slotDoQuery(QString*, QString* )) );
	  connect( tGen, SIGNAL( successfull() ), doc, SLOT( slotReConnect() ) );

	}	
}

void SqlGuiPart::slotBaseNew()
{

  cout << "SQLGUI: Request for creating base " << endl;
	if( isConnected()){
		baseCreator *bGen = new baseCreator( myParentWidget );
	  bGen->show();
	  connect( bGen, SIGNAL( createRequest( QString* ) ), doc, SLOT( slotDbCreate( QString* ) ) );
	}
}

void SqlGuiPart::slotFileOpen()
{
	
  if(!doc->saveModified())
  {
     // here saving wasn't successful

  }
  else
  {	
    LoginBox * log_box;
    log_box = new LoginBox( myParentWidget, "Login_box", false, 0 );
    log_box->show();
    connect( log_box, SIGNAL( loginRequest( QString, QString, QString )  ), doc, SLOT( slotDoLogin( QString, QString, QString )  ) );
    connect( log_box, SIGNAL( loginRequest( QString, QString, QString )  ), this, SLOT( slotAddConn()  ) );
  }
}

bool SqlGuiPart::openURL(const KURL& _url){

//  fileOpenRecent->addURL( _url );
//	saveOptions();

	// Kio-Support Job:
	//m_job = KIO::get( _url, false, false );
	//connect( m_job, SIGNAL( data( KIO::Job*, const QByteArray &)),
  //         this,  SLOT( slotData( KIO::Job*, const QByteArray &)));
	//connect( m_job, SIGNAL( redirection( KIO::Job*, const KURL &)),
  //         this,  SLOT( slotRedirection( KIO::Job*, const KURL &)));

	
	// Traditional, no KIO-support. Open directly:
	slotFileOpenRecent( _url );
	emit( setWindowCaption( _url.prettyURL() ) );
	return true;
}

bool SqlGuiPart::openFile(){
	return true;
}

void SqlGuiPart::slotRedirection( KIO::Job*, const KURL & url)
{
	openURL( url );
}

void SqlGuiPart::slotFileOpenRecent(const KURL& _url)
{
	
 	QString u = _url.user();
 	QString h = _url.host();
  unsigned short int po = _url.port();
 	QString p = _url.pass();

	cout << endl << endl;		
	cout << "KURL: " << _url.url().latin1() << endl;		
	cout << "recent user: " << u.latin1() << endl;
	cout << "recent host: " << h.latin1() << endl;
	cout << "recent port: " << po << endl;
	cout << "recent pass: " << p.latin1() << endl << endl;

    if (po > 0){
        h.append(":");
        QString pnum;
        pnum.setNum( po );
        h.append( pnum );
    }

	LoginBox * box;
	box = new LoginBox( myParentWidget, "LoginBox", false, 0, h, u );

  box->show();
  connect( box, SIGNAL( loginRequest( QString, QString, QString )  ), doc, SLOT( slotDoLogin( QString, QString, QString )  ) );
  connect( box, SIGNAL( loginRequest( QString, QString, QString )  ), this, SLOT( slotAddConnData(QString, QString, QString )  ) );

}

void SqlGuiPart::slotFileSave()
{
  view->slotExport();
}

void SqlGuiPart::slotFileSaveAs()
{
  view->slotExport();
}

void SqlGuiPart::slotAddConnData( QString h, QString u, QString p ){
   	KURL  rec_entry;
   	rec_entry.setUser( u );
   	rec_entry.setHost( h );
    #ifdef SAVEPASSINSECURE	
    rec_entry.setPass( p );
    #endif
   	rec_entry.setProtocol( "mysql" );
    if ( rec_entry.isValid() )fileOpenRecent->addURL( rec_entry );
    cout << "URL: " << rec_entry.url().latin1() << endl;
    saveOptions();
}

void SqlGuiPart::slotAddConn(){
   	KURL  rec_entry;
   	rec_entry.setUser( doc->getUser() );
   	rec_entry.setHost( doc->getHost() );
    rec_entry.setPort( doc->getPort() );
    /*
     * Note: KDE seems to strip away all passwords from URLs when adding them to the
     * recent-files-dialog. You may enable this, by exporting CXXFLAGS=SAVEPASSINSECURE,
     * but it won't give you the passwords back, if KDE doesn't allow it... :(
     *
     */
    #ifdef SAVEPASSINSECURE	
    rec_entry.setPass( doc->getPass() );
    #endif
   	rec_entry.setProtocol( "mysql" );
    if ( rec_entry.isValid() )fileOpenRecent->addURL( rec_entry );
    cout << "URL: " << rec_entry.url().latin1() << endl;
    saveOptions();
}

void SqlGuiPart::slotFileClose()
{
  cout << "slotFileClose..." << endl;
  saveOptions();
  doc->slotClearMemory();
  view->slotUpdateResultList();
}

void SqlGuiPart::slotFilePrint()
{
//  QPrinter printer;
//  if (printer.setup(this))
//  {
//    view->print(&printer);
//  }
}

void SqlGuiPart::slotFileQuit()
{
// ?
}

void SqlGuiPart::slotEditCut()
{
}

void SqlGuiPart::slotEditCopy()
{
}

void SqlGuiPart::slotEditPaste()
{
}

void SqlGuiPart::slotSetFastMode()
{
  if(!setFastMode->isChecked())
  {
    	view->slotSetFast(false);
  }
  else
  {
  	  view->slotSetFast(true);
  }
	saveOptions();
}


void SqlGuiPart::slotStatusMsg(const QString &text)
{
  emit( setStatusBarText( text ) );
}

